#version 330 core
out vec4 FragColor;
in vec2 TexCoords;

uniform sampler2D scene;
uniform sampler2D bloomBlur;
uniform sampler2D godRays;
uniform bool bloom;
uniform float exposure;

void main()
{             
    const float gamma = 1.0;
    vec3 hdrColor = texture(scene, TexCoords).rgb;      
    vec3 bloomColor = texture(bloomBlur, TexCoords).rgb;
	vec3 godRaysColor = texture(godRays, TexCoords).rgb;
   
   if(bloom) 
        hdrColor += bloomColor; // additive blending
		hdrColor += godRaysColor;

    vec3 result = vec3(1.0) - exp(-hdrColor * exposure);
    
    result = pow(result, vec3(1.0 / gamma));
    FragColor = vec4(result, 1.0f);

}